#! /usr/bin/perl

my $order_file  = 'ORDER.txt';
my $up_file     = 'index.html';
my $left_image  = '../img/left.png';
my $right_image = '../img/right.png';
my $up_image    = '../img/up.png';
my $blank_image = '../img/blank.png';

sub read_order_file {
    my ($file) = @_;
    my $htmls = [];

    open(ORDER, '<', $file) or die "failed to open the file, $!: $file\n";

    while (<ORDER>) {
	chomp;
	push(@$htmls, $_);
    }

    close(ORDER);
    return $htmls;
}

sub html_arrows {
    my ($left_file, $right_file, $up_file) = @_;
    my $result = '';

    if ($left_file ne '') {
	$result .= sprintf("<a href=\"%s\"><img src=\"%s\" alt=\"%s\"></a>\n",
			   $left_file, $left_image, '[left]');
    } else {
	$result .= sprintf("<img src=\"%s\" alt=\"\">\n", $blank_image);
    }

    if ($up_file ne '') {
	$result .= sprintf("<a href=\"%s\"><img src=\"%s\" alt=\"%s\"></a>\n",
			   $up_file, $up_image, '[up]');
    } else {
	$result .= sprintf("<img src=\"%s\" alt=\"\">\n", $blank_image);
    }

    if ($right_file ne '') {
	$result .= sprintf("<a href=\"%s\"><img src=\"%s\" alt=\"%s\"></a>\n",
			   $right_file, $right_image, '[right]');
    } else {
	$result .= sprintf("<img src=\"%s\" alt=\"\">\n", $blank_image);
    }

    return $result;
}

sub rewrite_html_file {
    my ($in_file, $out_file, $left_file, $right_file, $up_file) = @_;
    my $arrows = html_arrows($left_file, $right_file, $up_file);

    open(IN, '<', $in_file) or die "failed to open the file, $!: $in_file\n";
    open(OUT, '>', $out_file) or die "failed to open the file, $!: $out_file\n";

    while (<IN>) {
	if (m|<body>|) {
	    print OUT;
	    print OUT "<p>\n";
	    print OUT  $arrows;
	    print OUT "</p>\n";
	} elsif (m|</body>|) {
	    print OUT "<p>\n";
	    print OUT  $arrows;
	    print OUT "</p>\n";
	    print OUT;
	} else {
	    print OUT;
	}
    }

    close(OUT);
    close(IN);
}

$htmls = read_order_file($order_file);
for (my $i = 0; $i < @$htmls; $i++) {
    my $out_file   = $htmls->[$i];
    my $in_file    = $out_file . '.in';
    my $left_file  = ($i > 0) ? $htmls->[$i - 1] : '';
    my $right_file = ($i + 1 < @$htmls) ? $htmls->[$i + 1] : '';
    unlink($out_file);
    rewrite_html_file($in_file, $out_file, $left_file, $right_file,
		      $up_file);
}
